"use strict";
exports.__esModule = true;
var option_1 = require("../option");
var wrapper_1 = require("../wrapper");
/**
 * Maps this Array to an Array of Array | Option | ArrayOps using a mapper function then flattens it.
 */
function flatMap(fun) {
    var arr = this.value(), result = [];
    for (var i = 0; i < arr.length; i++) {
        var item = fun(arr[i], i);
        if (option_1.Option.isOption(item))
            item.isDefined() && result.push(item.get());
        else
            result.push.apply(result, wrapper_1.getValue(item));
    }
    return new wrapper_1.ArrayOps(result);
}
exports.flatMap = flatMap;
wrapper_1.ArrayOps.prototype.flatMap = flatMap;
