import { ArrayOps, ObjectOps } from '../wrapper';
declare module '../wrapper' {
    interface ArrayOps<A> {
        groupBy: typeof groupBy;
    }
}
/**
* Creates an object composed of keys generated from the results of running each element through a discriminator function.
* The corresponding value of each key is an array of the elements responsible for generating the key.
*/
export declare function groupBy<A>(this: ArrayOps<A>, discriminator: (item: A, index: number) => string | number): ObjectOps<Record<string, A[]>>;
