import { ObjectOps } from '../wrapper';
declare module '../wrapper' {
    interface ObjectOps<A> {
        remove: typeof remove;
    }
}
/**
 * Returns an Object where the given keys are removed.
 * To delete a nullable key from an object while preserving its type, use "update()"
 */
export declare function remove<K extends string, V>(this: ObjectOps<Record<K, V>>, ...keys: K[]): ObjectOps<Record<K, V>>;
