"use strict";
exports.__esModule = true;
var wrapper_1 = require("../wrapper");
/**
 * Returns an Object where the given keys are removed.
 * To delete a nullable key from an object while preserving its type, use "update()"
 */
function remove() {
    var keys = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        keys[_i] = arguments[_i];
    }
    var obj = this.value(), result = {};
    Object.keys(obj).forEach(function (key) { if (keys.indexOf(key) === -1)
        result[key] = obj[key]; });
    return new wrapper_1.ObjectOps(result);
}
exports.remove = remove;
wrapper_1.ObjectOps.prototype.remove = remove;
